Public Delegate Function MyFxDelegate(ByVal nNumVars As Integer, ByRef fX() As Double, ByRef fParam() As Double, ByVal nVarIndex As Integer) As Double
Public Delegate Function SayFxDelegate() As String

Public Class CRoots_NLE_Newton1


  Public Sub CalcRoots(ByVal nNumVars As Integer, ByRef fX() As Double, ByRef fParam() As Double, ByRef fToler() As Double, _
                       ByVal fEpsFx As Double, ByVal nMaxIter As Integer, ByRef nIter As Integer, ByVal MyFx As MyFxDelegate)

    Dim g(nNumVars) As Double
    Dim Jmat(nNumVars, nNumVars) As Double
    Dim H, fXJ, Fp As Double
    Dim I, J As Integer
    Dim bGoOn As Boolean

    nIter = 0
    bGoOn = True
    Do While bGoOn And nIter < nMaxIter

      nIter += 1
      If nIter > nMaxIter Then Exit Do

      For I = 0 To nNumVars - 1
        g(I) = MyFx(nNumVars, fX, fParam, I)
        For J = 0 To nNumVars - 1
          H = 0.01 * (1 + Math.Abs(fX(J)))
          fXJ = fX(J)
          fX(J) = fXJ + H
          Fp = MyFx(nNumVars, fX, fParam, I)
          fX(J) = fXJ
          Jmat(I, J) = (Fp - g(I)) / H
        Next
      Next

      ' solve for the guess improvements
      MatrixLibVb.SolveLU(Jmat, g, nNumVars)
      For I = 0 To nNumVars - 1
        fX(I) = fX(I) - g(I)
      Next

      ' check refinement convergence
      bGoOn = False
      For I = 0 To nNumVars - 1
        If Math.Abs(g(I)) > fToler(I) Then
          bGoOn = True
        End If
      Next

      ' check function convergence
      If bGoOn Then
        bGoOn = False
        For I = 0 To nNumVars - 1
          If Math.Abs(g(I)) > fEpsFx Then
            bGoOn = True
          End If
        Next
      End If
    Loop

  End Sub

End Class
